int NSOM = 100;
int epsil = 3;

int[] pere = new int[NSOM];
int[] poids = new int[NSOM];
int[][] fils = new int[NSOM][NSOM];

void setup(){
 generation();
 int r = calpoids(0);
 size(600,600);
 fill(255);stroke(0);background(255);
 dessineFils(0,true,0,0,float(width),float(height));

 for (int i=0; i<NSOM; i++){
   print(i+":"+pere[i]+" "+poids[i]+":");
   for (int j=0; j<NSOM; j++){
    if (fils[i][j] >= 0) print(fils[i][j]+" ");
   }
   println();
  }
}

void draw(){}

//////////// utilitaires

// generation de l'arbre aleatoire
void generation(){
 for (int i=0; i<NSOM; i++){
   pere[i] = int(random(0,i-1));
   poids[i] = 0;
   for (int j=0; j<NSOM; j++){
    fils[i][j] = -1;
   }
 }
 pere[0] = -1;

 // recherche des fils
 for (int i=0; i<NSOM; i++){
  int n=0;
  for (int j=1; j<NSOM; j++){
    if (pere[j] == i) {fils[i][n]=j;n++;}
  }
 }
}

// calcul des poids
int calpoids(int i){
int pds;
  if (fils[i][0] == -1) {poids[i] = 1; return 1;} // feuille
  else {
   pds = 0;
   for (int j=0; j<NSOM; j++){
     if (fils[i][j] >= 0) pds += calpoids(fils[i][j]);
   }
   poids[i] = pds;
   return pds;
  }
}

void dessineFils(int n, boolean enlargeur,int x, int y, float l, float h){
  rect(x,y,l,h);
  if (enlargeur) {
   float a = l/poids[n];
   int i = 0;
   while (fils[n][i] > 0){
     float lfils = a*poids[fils[n][i]];
     float hfils = h;
     dessineFils(fils[n][i], false, x+epsil,y+epsil,lfils-2*epsil,hfils);
     i++;
     x += lfils; // y inchang
   }
  }
  else {
   float a = h/poids[n];
   int i = 0;
   while (fils[n][i] > 0){
     float hfils = a*poids[fils[n][i]];
     float lfils = l;
     dessineFils(fils[n][i], true, x+epsil,y+epsil,lfils,hfils-2*epsil);
     i++;
     y += hfils; // x inchang
   }
  }
}


